<?php

// +---------------------------------------------------------------------------+
// | Menu Plugin 1.2 for Geeklog - The Ultimate Weblog                         |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// |                                                                           |
// | This is the main administrative interface to the menu plugin for Geeklog  |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett        - tomw@pigstye.net                            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');
        
// Only let Menu Admins access this page
if (!SEC_hasRights('menu.admin')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Menu administrative page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_MNU['access_denied']);
    $display .= $LANG_MNU['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}
 
/* 
* Main Function
*/

if ($action == $LANG_MNU['additem']) {
	DB_query("INSERT INTO mnu_index (m_pos, m_type, owner_id) values (100,1," . $_USER['uid'] . ")");
} else if ($action == $LANG_MNU['delumenu']) {
    DB_query("DELETE FROM mnu_user");
} else if ($action == $LANG_MNU['save']) {
	for ($i=0; $i < $recs; $i++) {
		$var = 'perm_owner' . $i;
		$po = SEC_getPermissionValue($$var);
		$var = 'perm_group' . $i;
		$pg = SEC_getPermissionValue($$var);
		$var = 'perm_members' . $i;
		$pm = SEC_getPermissionValue($$var);
		$var = "perm_anon" . $i;
		$pa = SEC_getPermissionValue($$var);
		$var = "m_type" . $i;
		DB_query("UPDATE mnu_index SET m_pos=" . $m_pos[$i] . ", m_type =" . $$var . ', m_label="' . $m_label[$i] . '", m_url="' . $m_url[$i] . '",' 
				. ' owner_id=' . $owner_id[$i] . ', group_id=' . $group_id[$i] . ', perm_owner=' . $po . ','
				. ' perm_group=' . $pg . ', perm_members=' . $pm . ', perm_anon=' . $pa . ''
				. " WHERE m_id='" . $m_id[$i] . "'");
	}	
} else if ($action == 'delete') {
	DB_query("DELETE FROM mnu_index WHERE m_id='$m_id'");
}
$display = COM_siteHeader();
$display .= COM_startBlock($LANG_MNU['menuPeditor']);
$T = new Template($_CONF['path'] . 'plugins/menu/templates/');
$T->set_file('admin','admin.thtml');
$T->set_block('admin','item','AnItem');
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('site_admin_url',$_CONF['site_admin_url']);
$T->set_var('admin_header',$LANG_MNU['menueditor']);
$T->set_var('adminmsg1',$LANG_MNU['editmsg1']);
$T->set_var('adminmsg2',$LANG_MNU['editmsg2']);
$T->set_var('savemsg',$LANG_MNU['save']);
$T->set_var('newmsg',$LANG_MNU['additem']);
$T->set_var('delmen',$LANG_MNU['delumenu']);
$T->set_var('delete_msg',$LANG_MNU['delete']);
$retval=DB_query("SELECT * FROM mnu_index ORDER BY m_pos");
$nrows=DB_numRows($retval);
$T->set_var('nrows',$nrows);
for($i=0;$i<$nrows;$i++){
	$A=DB_fetchArray($retval);
	$T->set_var('m_pos',$A['m_pos']);
	$T->set_var('pos_label',$LANG_MNU['position']);
	for ($j = 1; $j < 6; $j++) {
		if ($A['m_type'] == $j) {
			$T->set_var("checked{$j}",'checked');
		} else {
			$T->set_var("checked{$j}",'');
		}
	}
	$T->set_var('type_label',$LANG_MNU['type']);
	$T->set_var('type1_label',$LANG_MNU['url']);
	$T->set_var('type2_label',$LANG_MNU['label']);
	$T->set_var('type3_label',$LANG_MNU['stories']);
	$T->set_var('type4_label',$LANG_MNU['user']);
	$T->set_var('type5_label',$LANG_MNU['admin']);
	$T->set_var('m_label',$A['m_label']);
	$T->set_var('label_label',$LANG_MNU['label']);
	$T->set_var('m_url',$A['m_url']);
	if ($A['m_type'] == 1) {
		$T->set_var('url_label',$LANG_MNU['url']);
		$T->set_var('url_type','text');
	} else {
		$T->set_var('url_label','');
		$T->set_var('url_type','hidden');
	}
	$T->set_var('i',$i);
	$T->set_var('m_id',$A['m_id']);
	$T->set_var('lang_accessrights', $LANG_ACCESS[accessrights]);
	$T->set_var('lang_owner', $LANG_ACCESS[owner] . ':');
	if (SEC_inGroup('Root')) {
		$T->set_var('owner_username', '');
		$usrdd = '<SELECT name="owner_id[]">' . COM_optionList($_TABLES['users'],"uid,username",$A['owner_id']) . "</SELECT>";
		$T->set_var('owner_id',$usrdd);
	} else {
		$T->set_var('owner_username', '&nbsp;&nbsp;&nbsp' . DB_getItem($_TABLES['users'],'username',"uid = {$c_oid}"));
		$T->set_var('owner_id', "<input type='hidden' name='owner_id[]' value='" . $A['owner_id'] . "'>");
	}
	$T->set_var('lang_group', $LANG_ACCESS['group'] . ':');
	$usergroups = SEC_getUserGroups();
	$groupdd = '<SELECT name="group_id[]">';
	for ($k = 0; $k < count($usergroups); $k++) {
		$groupdd .= '<option value="' . $usergroups[key($usergroups)] . '"';
	    if ($A['group_id'] == $usergroups[key($usergroups)]) {
    		$groupdd .= ' SELECTED';
	    }
  		$groupdd .= '>' . key($usergroups) . '</option>';
	    next($usergroups);
	}
	$groupdd .= '</SELECT>';
	$T->set_var('group_dropdown', $groupdd);
	$T->set_var('lang_owner',$LANG_ACCESS['owner']);
	$T->set_var('lang_group',$LANG_ACCESS['group']);
	$T->set_var('lang_members',$LANG_ACCESS['members']);
	$T->set_var('lang_anonymous',$LANG_ACCESS['anonymous']);
	if ($A['perm_owner'] >= 2) {
		$T->set_var('ownerR','checked');
	} else {
		$T->set_var('ownerR','');
	}
	if ($A['perm_group'] >= 2) {
		$T->set_var('groupR','checked');
	} else {
		$T->set_var('groupR','');
	}
	if ($A['perm_members'] >= 2) {
		$T->set_var('membersR','checked');
	} else {
		$T->set_var('membersR','');
	}
	if ($A['perm_anon'] >= 2) {
		$T->set_var('anonR','checked');
	} else {
		$T->set_var('anonR','');
	}
	$T->Parse('AnItem','item',true);
}
$T->Parse('output','admin');
$display .= $T->finish($T->get_var('output'));
$display .= COM_endBlock();
$display .= COM_siteFooter(true);

echo $display;

?>