<?php

// +---------------------------------------------------------------------------+
// | Menu Plugin 1.2 for Geeklog - The Ultimate Weblog                         |
// +---------------------------------------------------------------------------+
// | upgrade.php                                                               |
// |                                                                           |
// | This file upgrades the Menu plugin for Geeklog.                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett        - tomw@pigstye.net                            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');
$langfile = $_CONF['path'] . 'plugins/menu/language/' . $_CONF['language'] . '.php';
if (file_exists ($langfile)) {
    require_once ($langfile);
} else {
    require_once ($_CONF['path'] . 'plugins/menu/language/english.php');
}

// Only let Root users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Menu install/uninstall page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_MNU['access_denied']);
    $display .= $LANG_MNU['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}
 
/* 
* Upgrade from 1.0 to 1.2
* 
*/
function plugin_upgrade_menu() 
{
    global $_TABLES;
    
    DB_query("UPDATE {$_TABLES['plugins']} SET pi_version='1.2' WHERE pi_name = 'menu'",1);    
    COM_errorLog("Menu Plugin upgraded to 1.2",1);
}

/* 
* Main Function
*/

$display = COM_siteHeader();
$display .= COM_startBlock($LANG_MNU['upgrade_head']);

if ($action == 'upgrade') {
    plugin_upgrade_menu();
} else if ($action == 'install') {
    print COM_refresh($_CONF[site_admin_url] . '/plugins/menu/install.php');
    exit;
}

$result = DB_query("SELECT * FROM " . $_TABLES['plugins'] . " WHERE pi_name = 'menu'");
$nrows = DB_numRows($result);

if ($nrows == 0) {
	$T = new template($_CONF['path'] . 'plugins/menu/templates');
	$T->set_file('install', 'upgrade.thtml');
	$T->set_var('site_url',$_CONF['site_url']);
	$T->set_var('site_admin_url',$_CONF['site_admin_url']);
	$T->set_var('install_header',$LANG_MNU['notinstalled']);
	$T->set_var('installmsg1',$LANG_MNU['notinstalled_msg2']);
	$T->set_var('installmsg2',"");
	$T->set_var('btnmsg',$LANG_MNU['install']);
	$T->set_var('action','install');
	$T->parse('output','install');
    $display .= $T->finish($T->get_var('output'));
} else {
    $A = DB_fetchArray($result);
    if ($A['pi_version'] == '1.2') {
    	$T = new template($_CONF['path'] . 'plugins/menu/templates');
	    $T->set_file('install', 'upgrade.thtml');
    	$T->set_var('site_url',$_CONF['site_url']);
	    $T->set_var('site_admin_url',$_CONF['site_admin_url']);
    	$T->set_var('install_header',$LANG_MNU['installed']);
	    $T->set_var('installmsg1',$LANG_MNU['upgrade_msg']);
    	$T->set_var('installmsg2',$LANG_MNU['up_complete']);
	    $T->set_var('btnmsg',$LANG_MNU['upgrade']);
    	$T->set_var('action','nothing');
	    $T->parse('output','install');
        $display .= $T->finish($T->get_var('output'));
    } else {
    	$T = new template($_CONF['path'] . 'plugins/menu/templates');
	    $T->set_file('install', 'upgrade.thtml');
    	$T->set_var('site_url',$_CONF['site_url']);
	    $T->set_var('site_admin_url',$_CONF['site_admin_url']);
    	$T->set_var('install_header',$LANG_MNU['installed']);
	    $T->set_var('installmsg1',$LANG_MNU['upgrade_msg']);
    	$T->set_var('installmsg2',$LANG_MNU['upgrade_msg2']);
	    $T->set_var('btnmsg',$LANG_MNU['upgrade']);
    	$T->set_var('action','upgrade');
	    $T->parse('output','install');
        $display .= $T->finish($T->get_var('output'));
    }
}

$display .= COM_endBlock();
$display .= COM_siteFooter(true);

echo $display;

?>