<?php
//
// +---------------------------------------------------------------------------+
// | Menu Plugin 1.2 for Geeklog - The Ultimate Weblog                         |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// | This file does two things: 1) it implements the necessary Geeklog Plugin  |
// | API method and 2) implements all the common code needed by the Contact    |
// | PHP files.                                                                |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett       - tomw*pigstye.net                             |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

$langfile = $_CONF['path'] . 'plugins/menu/language/' . $_CONF['language'] . '.php';
if (file_exists ($langfile)) {
    require_once ($langfile);
} else {
    require_once ($_CONF['path'] . 'plugins/menu/language/english.php');
}

require_once ($_CONF['path'] . 'plugins/menu/config.php');
        
// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
*/
function plugin_getmenuitems_menu()
{
    $menuitems = array();
    return $menuitems;
}

/**
* Geeklog is checking to see if this plugin supports comments, tell it no!
* NOTE: to support comments you must use the same date/time based ID for your
* widget.  In other words, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
*/
function plugin_commentsupport_menu() 
{
    // Static Pages will not use comments
    return false;
}

/**
* Shows the statistics for the menu plugin on stats.php.  If
* $showsitestats is 1 then we are to only print the overall stats in the 'site
* statistics' box otherwise we show the detailed stats for the menu
*
* @showsitestate        int         Flag to let us know which stats to get
*/
function plugin_showstats_menu($showsitestats) 
{
    $retval = '';
	return $retval;
}

/**
* This will put an option for menu in the command and control block on
* moderation.php
*
*/
function plugin_cclabel_menu() 
{
    global $_CONF, $LANG_MNU;

    return array($LANG_MNU['menueditor'],$_CONF['site_admin_url'] . '/plugins/menu/index.php',$_CONF['site_url'] . '/menu/images/menu.gif');
}

/**
* returns the administrative option for this plugin
*
*/
function plugin_getadminoption_menu() {
    global $_CONF, $LANG_MNU;

    if (SEC_hasRights('menu.admin')) {
        return array($LANG_MNU['menueditor'], $_CONF['site_admin_url'] . '/plugins/menu/index.php', 0);
    }
}

/**
* returns the user option for this plugin
*
*/
function plugin_getuseroption_menu() 
{
    global $_CONF, $LANG_MNU, $CONFIG_MENU;

    if ($CONFIG_MENU['usermenu'] == 1) {
        return array($LANG_MNU['menueditor'], $_CONF['site_url'] . '/menu/index.php', 0);
    }
}


/**
* Removes the datastructures for this plugin from the Geeklog database
*
* This may get called by the install routine to undue anything done to this
* point.  To do that, $steps will have a list of steps to undo
*
*/  
function plugin_uninstall_menu()
{
    global $_TABLES;

    // Uninstalls the menu plugin

    // Remove the menu tables
    COM_errorLog('Dropping menu index table',1);
    DB_query("DROP TABLE mnu_index",1);
    COM_errorLog('...success',1);
    COM_errorLog('Dropping menu user table',1);
    DB_query("DROP TABLE mnu_user",1);
    COM_errorLog('...success',1);

	// Remove menu block
	DB_query("DELETE FROM " . $_TABLES['blocks'] . " where name='menu_plugin'");
	
    // Remove security for this plugin

    // Remove the menu admin group
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = 'menu_group_id'");

    COM_errorLog('Attempting to remove the Menu Admin Group', 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    COM_errorLog('...success',1);

    // Remove related features
    $edit_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'menu.edit'");
    $admin_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'menu.admin'");

    // Remove access to those features 
    COM_errorLog('Attempting to remove rights to menu.view from all groups',1);
    DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $view_id",1);
    COM_errorLog('...success',1);

    // Remove access to those features 
    COM_errorLog('Attempting to remove rights to menu.edit from all groups',1);
    DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $edit_id",1);
    COM_errorLog('...success',1);

    // Remove access to those features 
    COM_errorLog('Attempting to remove rights to menu.admin from all groups',1);
    DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $admin_id",1);
    COM_errorLog('...success',1);

    // Remove root users from the group
    COM_errorLog('Attempting to remove root users from admin of menu');
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);
    COM_errorLog('...success',1);

    COM_errorLog('Attempting to remove the menu.edit feature',1);
    DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $view_id",1);
    COM_errorLog('...success',1);

    COM_errorLog('Attempting to remove the menu.edit feature',1);
    DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $edit_id",1);
    COM_errorLog('...success',1);

    COM_errorLog('Attempting to remove the menu.admin feature',1);
    DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $admin_id",1);
    COM_errorLog('...success',1);

    COM_errorLog('Attempting to remove the group id from the vars table',1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'menu_group_id'",1);
    COM_errorLog('success',1);


    // Unregister the plugin with Geeklog
    COM_errorLog('Attempting to unregister the plugin from Geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'menu'",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'menu'");
    COM_errorLog('...success',1);

    COM_errorLog('Finished uninstalling Menu',1);
    return true;
}

/*
*
*************************************************************************************************
* Code for plugin begins here
*************************************************************************************************
*
*/
/**
* Actual code that generates menu 
*
*/
function phpblock_menu_plugin() {
	global $_CONF, $_USER;
	
	$result = DB_query("SELECT * FROM mnu_user WHERE owner_id='" . $_USER['uid'] . "' ORDER BY m_pos ASC");
	$nrows = DB_numRows($result);
	if ($nrows == 0) {
		$result = DB_query("SELECT * FROM mnu_index WHERE " . MNU_getPerms() . " ORDER BY m_pos ASC");
		$nrows = DB_numRows($result);
	}
    $T = new Template( $_CONF['path_layout'] );
    $T->set_file( 'option', 'useroption.thtml' );
    $T->set_var('layout_url',$_CONF['layout_url']);
    $TL = new Template($_CONF['path'] . '/plugins/menu/templates');
    $TL ->set_file('label','menubar.thtml');
	for ($i=0;$i<$nrows;$i++) {
		$A = DB_fetchArray($result);
		switch ($A['m_type']) {
			case '1';
	            $T->set_var( 'option_url', $A['m_url']);
    	        $T->set_var( 'option_label', $A['m_label']);
    	        $T->set_var( 'option_count','');
	            $retval .= $T->parse( 'item', 'option' );
				break;
			case '2';
	            $TL->set_var('m_label',$A['m_label']);
	            $retval .= $TL->parse('item','label');
				break;
			case '3';
				if ($A['m_label'] != '') {
		            $TL->set_var('m_label',$A['m_label']);
		            $retval .= $TL->parse('item','label');
				}
				$retval .= MNU_showTopics();
				break;
			case '4';
				if ($A['m_label'] != '') {
		            $TL->set_var('m_label',$A['m_label']);
		            $retval .= $TL->parse('item','label');
				}
				$retval .=MNU_userMenu();
				break;
			case '5';
				$tmp = MNU_adminMenu();
				if ($tmp != '') {
				if ($A['m_label'] != '') {
		            $TL->set_var('m_label',$A['m_label']);
		            $retval .= $TL->parse('item','label');
				}
				$retval .= $tmp;
				}
				break;
		}
	}
	return $retval;
}

/** 
* Shows all available topics
*
* Show the topics in the system the user has access to and prints them in HTML.
* Topics have href and are seperated by line breaks.
* Adapted form lib-common
*
* @return	string	  HTML formated topic list
*
*/

function MNU_showTopics() 
{
    global $_TABLES, $_CONF, $_USER, $LANG01, $HTTP_SERVER_VARS, $page;

    if( $_CONF['sortmethod'] == 'alpha' )
    {
        $result = DB_query( "SELECT * FROM {$_TABLES['topics']} ORDER BY tid ASC" );
    } 
    else
    {
        $result = DB_query( "SELECT * FROM {$_TABLES['topics']} ORDER BY sortnum" );
    }

    $nrows = DB_numRows( $result );
    $T = new Template( $_CONF['path_layout'] );
    $T->set_file( 'option', 'useroption.thtml' );

    for( $i = 0; $i < $nrows; $i++ ) {
        $A = DB_fetchArray( $result );
        if( SEC_hasAccess( $A['owner_id'], $A['group_id'], $A['perm_owner'], $A['perm_group'], $A['perm_members'], $A['perm_anon']) > 0 )
        {
            $T->set_var( 'option_url', $_CONF['site_url'] . '/index.php?topic=' . $A['tid']);
            $T->set_var( 'option_label', $A['topic']);
            if( $_CONF['showstorycount'] + $_CONF['showsubmissioncount'] > 0 ) {
            	$cnt = '(';
                if( $_CONF['showstorycount'] ) {
                	$rcount = DB_query( "SELECT count(*) AS count FROM {$_TABLES['stories']} WHERE draft_flag = 0 AND date <= NOW() AND tid = '{$A['tid']}'" );
                    $R = DB_fetchArray( $rcount );
                    $cnt .= $R['count'];
                }
                if( $_CONF['showsubmissioncount'] ) {
					if( $_CONF['showstorycount'] ) {
						$cnt .= '/';
                    }
                    $cnt .= DB_count( $_TABLES['storysubmission'], 'tid', $A['tid'] );
                }
                $cnt .= ')';
            }
            $T->set_var('option_count', $cnt);
            $retval .= $T->parse( 'item', 'option' );
        }
    }
    return $retval;
}

/**
* Shows the user their menu options
*
* This shows the average joe use their menu options. This is the user block on right side
* Adapted from lib-common
*
*/

function MNU_userMenu() 
{
    global $_TABLES, $_USER, $_CONF, $LANG01;

    if( $_USER['uid'] > 1 )
    {
        $T = new Template( $_CONF['path_layout'] );
        $T->set_file( 'option', 'useroption.thtml' );

        if( empty( $title )) 
        {
            $title = DB_getItem( $_TABLES['blocks'], 'title', "name='user_block'" );
        }
        
        if( $_CONF['personalcalendars'] == 1 ) 
        {
            $T->set_var( 'option_url', $_CONF['site_url'] . '/calendar.php?mode=personal' );
            $T->set_var( 'option_label', $LANG01[66] );
            $T->set_var( 'option_count', '' );
            
            $retval .= $T->parse( 'item', 'option' );
        }

        // This function will show the user options for all installed plugins (if any)

        $plugin_options = PLG_getUserOptions();
        $nrows = count( $plugin_options );
        
        for( $i = 1; $i <= $nrows; $i++ )
        {
            $plg = current( $plugin_options );
            $T->set_var( 'option_url', $plg->adminurl );
            $T->set_var( 'option_label', $plg->adminlabel );

            if( !empty($plg->numsubmissions )) 
            {
                $T->set_var( 'option_count', '(' . $plg->numsubmissions . ')' );
            }
            else 
            {
                $T->set_var( 'option_count', '' );
            }
            
            $retval .= $T->parse( 'item', 'option' );

            next( $plugin_options );
        }
        
        $T->set_var( 'option_url', $_CONF['site_url'] . '/usersettings.php?mode=edit' );
        $T->set_var( 'option_label', $LANG01[48] );
        $T->set_var( 'option_count', '' );
        $retval .= $T->parse( 'item', 'option' );

        $T->set_var( 'option_url', $_CONF['site_url'] . '/usersettings.php?mode=preferences' );
        $T->set_var( 'option_label', $LANG01[49] );
        $T->set_var( 'option_count', '' );
        $retval .= $T->parse( 'item', 'option' );

        $T->set_var( 'option_url', $_CONF['site_url'] . '/usersettings.php?mode=comments' );
        $T->set_var( 'option_label', $LANG01[63] );
        $T->set_var( 'option_count', '' );
        $retval .= $T->parse( 'item', 'option' );

        $T->set_var( 'option_url', $_CONF['site_url'] . '/users.php?mode=logout' );
        $T->set_var( 'option_label', $LANG01[19] );
        $T->set_var( 'option_count', '' );
        $retval .= $T->parse( 'item', 'option' );

    } 
    else 
    {
        $retval .= '<form action="' . $_CONF['site_url'] . '/users.php" method="post">' . LB
            . '<b>' . $LANG01[21] . ':</b><br>' . LB
            . '<input type="text" size="10" name="loginname" value=""><br>' . LB
            . '<b>' . $LANG01[57] . ':</b><br>' . LB
            . '<input type="password" size="10" name="passwd"><br>' . LB
            . '<input type="submit" value="' . $LANG01[58] . '">' . LB
            . '</form>' . $LANG01[59];
    }

    return $retval;
}


/**
* Prints administration menu
*
* This will return the administration menu items that the user has
* sufficient rights to -- Admin Block on right side.
*
* @see function COM_userMenu
*
*/

function MNU_adminMenu() 
{
    global $_TABLES, $_USER, $_CONF, $LANG01;

    if( SEC_isModerator() OR SEC_hasrights( 'story.edit,block.edit,topic.edit,link.edit,event.edit,poll.edit,user.edit,plugin.edit,user.mail', 'OR' ))
    {
        $T = new Template( $_CONF['path_layout'] );
        $T->set_file( 'option', 'useroption.thtml' );

        if( SEC_isModerator() ) 
        {
            $num = 0;
            
            if( SEC_hasrights( 'story.edit' )) 
            {
                $num += DB_count( $_TABLES['storysubmission'], 'uid', 0 );
            }
            
            if( SEC_hasrights( 'event.edit' ))
            { 
                $num += DB_count ($_TABLES['eventsubmission'], 'eid', 0);
            }
            
            if( SEC_hasrights( 'link.edit' )) 
            { 
                $num += DB_count( $_TABLES['linksubmission'], 'lid', 0 );
            }
            
            if( SEC_hasrights( 'user.edit' ) && SEC_hasrights( 'user.delete' ))
            {
                $emptypwd = md5( '' );
                $num += DB_count( $_TABLES['users'], 'passwd', $emptypwd );
            }

            //now handle submissions for plugins
            
            $num = $num + PLG_getSubmissionCount();
            
            $T->set_var( 'option_url', $_CONF['site_admin_url'] . '/moderation.php' );
            $T->set_var( 'option_label', $LANG01[10] );
            $T->set_var( 'option_count', '(' . $num . ')' );
            
            $retval .= $T->parse( 'item', 'option' );
        }
        
        if( SEC_hasrights( 'story.edit' )) 
        {
            $T->set_var( 'option_url', $_CONF['site_admin_url'] . '/story.php' );
            $T->set_var( 'option_label', $LANG01[11] );
            $T->set_var( 'option_count', '(' . DB_count( $_TABLES['stories']) . ')');
            
            $retval .= $T->parse('item', 'option' );
        }
        
        if( SEC_hasrights( 'block.edit' )) 
        {
            $T->set_var( 'option_url', $_CONF['site_admin_url'] . '/block.php' );
            $T->set_var( 'option_label', $LANG01[12] );
            $T->set_var( 'option_count', '(' . DB_count( $_TABLES['blocks'] ) . ')');
            
            $retval .= $T->parse( 'item', 'option' );
        }
        
        if( SEC_hasrights( 'topic.edit' ))
        {
            $T->set_var( 'option_url', $_CONF['site_admin_url'] . '/topic.php' );
            $T->set_var( 'option_label', $LANG01[13] );
            $T->set_var( 'option_count', '(' . DB_count( $_TABLES['topics']) . ')');
            
            $retval .= $T->parse( 'item', 'option' );
        }
        
        if( SEC_hasrights( 'link.edit' )) 
        {
            $T->set_var( 'option_url', $_CONF['site_admin_url'] . '/link.php' );
            $T->set_var( 'option_label', $LANG01[14] );
            $T->set_var( 'option_count', '(' . DB_count( $_TABLES['links'] ) . ')');
            
            $retval .= $T->parse( 'item', 'option' );
        }
        
        if( SEC_hasrights( 'event.edit' ))
        {
            $T->set_var( 'option_url', $_CONF['site_admin_url'] . '/event.php') ;
            $T->set_var( 'option_label', $LANG01[15] );
            $T->set_var( 'option_count', '(' . DB_count( $_TABLES['events'] ) . ')');
            
            $retval .= $T->parse( 'item', 'option' );
        }
        
        if( SEC_hasrights( 'poll.edit' )) 
        {
            $T->set_var( 'option_url', $_CONF['site_admin_url'] . '/poll.php' );
            $T->set_var( 'option_label', $LANG01[16] );
            $T->set_var( 'option_count', '(' . DB_count( $_TABLES['pollquestions'] ) . ')');
        
            $retval .= $T->parse( 'item', 'option' );
        }
        
        if( SEC_hasrights( 'user.edit' ))
        {
            $T->set_var( 'option_url', $_CONF['site_admin_url'] . '/user.php' );
            $T->set_var( 'option_label', $LANG01[17] );
            $T->set_var( 'option_count', '(' . ( DB_count( $_TABLES['users'] ) -1 ) . ')');
            
            $retval .= $T->parse( 'item', 'option' );
        }
        
        if( SEC_hasrights( 'group.edit' ))
        {
            $T->set_var( 'option_url', $_CONF['site_admin_url'] . '/group.php' );
            $T->set_var( 'option_label', $LANG01[96] );
            $T->set_var( 'option_count', '(' . DB_count( $_TABLES['groups'] ) . ')');
            
            $retval .= $T->parse( 'item', 'option' );
        }
        
        if( SEC_hasrights( 'user.mail' ))
        {
            $T->set_var( 'option_url', $_CONF['site_admin_url'] . '/mail.php' );
            $T->set_var( 'option_label', $LANG01[105] );
            $T->set_var( 'option_count', '' );
            
            $retval .= $T->parse( 'item', 'option' );
        }
        
        if( SEC_hasrights( 'plugin.edit' ))
        {
            $T->set_var( 'option_url', $_CONF['site_admin_url'] . '/plugins.php' );
            $T->set_var( 'option_label', $LANG01[77] );
            $T->set_var( 'option_count', '(' . DB_count( $_TABLES['plugins'] ) . ')');
            
            $retval .= $T->parse( 'item', 'option' );
        }

        // This function will show the admin options for all installed plugins (if any)
        
        $plugin_options = PLG_getAdminOptions();
        $nrows = count( $plugin_options );
        for( $i = 1; $i <= $nrows; $i++ )
        {
            $plg = current( $plugin_options );
            
            $T->set_var( 'option_url', $plg->adminurl );
            $T->set_var( 'option_label', $plg->adminlabel );
            
            if( empty( $plg->numsubmissions ))
            {
                $T->set_var( 'option_count', '' );
            }
            else
            {
                $T->set_var( 'option_count','(' . $plg->numsubmissions . ')');
            }
            
            $retval .= $T->parse( 'item', 'option', true );
            
            next( $plugin_options );
        }
             
        if( $_CONF['allow_mysqldump'] == 1 AND SEC_inGroup( 'Root' )) 
        {
            $T->set_var( 'option_url', $_CONF['site_admin_url'] . '/database.php' );
            $T->set_var( 'option_label', $LANG01[103] );
            $T->set_var( 'option_count', '' );
            
            $retval .= $T->parse( 'item', 'option' );
        }

        if(SEC_inGroup( 'Root' )) 
        {
        	$T->set_var( 'option_url', 'http://geeklog.sourceforge.net/versionchecker.php?version=' . VERSION );
        	$T->set_var( 'option_label', $LANG01[107] );
       		 $T->set_var( 'option_count', '' );
	        $retval .= $T->parse( 'item', 'option' );
        }
    }
    
    return $retval;
}

/**
* Return SQL where statement with appropriate permissions
*
* Takes User id and permission and returns SQL where clause which will return the appropriate objects.
* This assumes that the table has the following security structure:
* owner_id        | mediumint(8)          
* group_id        | mediumint(8)          
* perm_owner      | tinyint(1) unsigned   
* perm_group      | tinyint(1) unsigned   
* perm_members    | tinyint(1) unsigned  
* perm_anon       | tinyint(1) unsigned  
* This will work with the standard GL tables
*
* @table	str	Table name (used in joins)
* @access	int	Access if blank read access  2 = read 3 = read/edit
* @u_id int     User ID if blank current user
*
* @return string	Where clause of sql statement
*
*/

function MNU_getPerms($table='',$access='2',$u_id='') {
	global $_USER, $_GROUPS;
	
	if ($table != '') { $table .= '.'; }
	if ($u_id == '') {
		$uid = $_USER['uid'];
		$GROUPS = $_GROUPS;
	} else {
		$uid = $u_id;
		$GROUPS = SEC_getUserGroups($uid);
	}
    if ($uid <= 1) {
       	$where = "((" . $table . "perm_anon >= $access)";
    } else {
       	$where = "((" . $table . "perm_anon >= 3)";
    }
	// check to see if anonymous user
	if ($uid > 1) {
		$where .= " OR (" . $table . "perm_members >= $access)";
		foreach ($GROUPS as $group) {
			$where .= " OR ((" . $table . "group_id = $group) AND (" . $table . "perm_group >= $access))";
		}
		$where .= " OR ((" . $table . "owner_id = $uid) AND (" . $table . "perm_owner >= $access))";
	}
	return $where . ")"; 
}

?>