<?php

// +---------------------------------------------------------------------------+
// | Menu Plugin 1.2 for Geeklog - The Ultimate Weblog                         |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// |                                                                           |
// | This is the main user interface to the menu plugin for Geeklog            |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett        - tomw@pigstye.net                            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');
        
// Only allow members to access if menu editing is allowed
if (($CONFIG_MENU['usermenu'] != 1) || ($_USER['uid'] < 2)) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Menu edit page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_MNU['access_denied']);
    $display .= $LANG_MNU['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}
 
/* 
* Main Function
*/

if ($action == $LANG_MNU['additem']) {
	DB_query("INSERT INTO mnu_user (m_pos, m_type, owner_id) values (100,1," . $_USER['uid'] . ")");
} else if ($action == $LANG_MNU['save']) {
	for ($i=0; $i < $recs; $i++) {
		$var = 'm_type' . $i;
		DB_query("UPDATE mnu_user SET m_pos=" . $m_pos[$i] . ", m_type =" . $$var . ', m_label="' . $m_label[$i] . '", m_url="' . $m_url[$i] . '"' 
				. " WHERE m_id='" . $m_id[$i] . "'");
	}	
} else if ($action == 'delete') {
	DB_query("DELETE FROM mnu_user WHERE m_id='$m_id'");
}

$display = COM_siteHeader();
$display .= COM_startBlock($LANG_MNU['menuPeditor']);
$T = new Template($_CONF['path'] . 'plugins/menu/templates/');
$T->set_file('admin','index.thtml');
$T->set_block('admin','item','AnItem');
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('site_admin_url',$_CONF['site_admin_url']);
$T->set_var('admin_header',$LANG_MNU['menueditor']);
$T->set_var('adminmsg1',$LANG_MNU['editmsg1']);
$T->set_var('savemsg',$LANG_MNU['save']);
$T->set_var('newmsg',$LANG_MNU['additem']);
$T->set_var('delete_msg',$LANG_MNU['delete']);
$retval=DB_query("SELECT * FROM mnu_user WHERE owner_id=" . $_USER['uid'] . " ORDER BY m_pos");
$nrows=DB_numRows($retval);
if ($nrows == 0) {
	$retval=DB_query("SELECT * FROM mnu_index ORDER BY m_pos");
	$nrows=DB_numRows($retval);
	for($i=0;$i<$nrows;$i++) {
		$A=DB_fetchArray($retval);
		DB_query("INSERT INTO mnu_user SET owner_id=" . $_USER['uid'] . ", m_pos=" . $A['m_pos'] . ",m_type=" . $A['m_type'] . ',m_label="' . $A['m_label'] . '",m_url="' . $A['m_url'] . '"');
	}
	$retval=DB_query("SELECT * FROM mnu_user WHERE owner_id=" . $_USER['uid'] . " ORDER BY m_pos");
	$nrows=DB_numRows($retval);
}
$T->set_var('nrows',$nrows);
for($i=0;$i<$nrows;$i++){
	$A=DB_fetchArray($retval);
	$T->set_var('m_pos',$A['m_pos']);
	$T->set_var('pos_label',$LANG_MNU['position']);
	for ($j = 1; $j < 6; $j++) {
		if ($A['m_type'] == $j) {
			$T->set_var("checked{$j}",'checked');
		} else {
			$T->set_var("checked{$j}",'');
		}
	}
	$T->set_var('type_label',$LANG_MNU['type']);
	$T->set_var('type1_label',$LANG_MNU['url']);
	$T->set_var('type2_label',$LANG_MNU['label']);
	$T->set_var('type3_label',$LANG_MNU['stories']);
	$T->set_var('type4_label',$LANG_MNU['user']);
	$T->set_var('type5_label',$LANG_MNU['admin']);
	$T->set_var('m_label',$A['m_label']);
	$T->set_var('label_label',$LANG_MNU['label']);
	$T->set_var('m_url',$A['m_url']);
	if ($A['m_type'] == 1) {
		$T->set_var('url_label',$LANG_MNU['url']);
		$T->set_var('url_type','text');
	} else {
		$T->set_var('url_label','');
		$T->set_var('url_type','hidden');
	}
	$T->set_var('i',$i);
	$T->set_var('m_id',$A['m_id']);
	$T->Parse('AnItem','item',true);
}
$T->Parse('output','admin');
$display .= $T->finish($T->get_var('output'));
$display .= COM_endBlock();
$display .= COM_siteFooter(true);

echo $display;

?>